BrowseTable = LibStub("AceAddon-3.0"):NewAddon("BrowseTable")
local BrowseTable = BrowseTable

function BrowseTable:OnInitialize()
	self.options = {type='group', handler=BrowseTable, args={}}
	LibStub("AceConfig-3.0"):RegisterOptionsTable("BrowseTable", self.options)
end

local function tablebrowser(t)
	local tabs = 0
	local descs = 0
	local ret = {}
	for key, value in pairs(t) do
		local ty = type(value)
		if ty == "table" then
			ret["tab"..(tabs+1)] = {
				type = "group",
				name = tostring(key),
				order = tabs+1,
				args = tablebrowser(value),
			}
			tabs = tabs+1
		elseif ty == "function" then
			ret[tostring(descs+1)] = {
				type = "description",
				name = tostring(key),
				width = "default",
				order = descs+1,
			}
			descs = descs+1
			ret[tostring(descs+1)] = {
				type = "execute",
				name = --[["function"--]]tostring(value),
				func = value,
				order = descs+1,
				--width = "half"
			}
			descs=descs+1
			--[[ret[tostring(descs+1)] = {
				type = "description",
				name = "",
				width = "half",
				order = descs+1,
			}
			descs = descs+1--]]
		else
			ret[tostring(descs+1)] = {
				type = "description",
				name = tostring(key),
				width = "default",
				order = descs+1,
			}
			descs = descs+1
			ret[tostring(descs+1)] = {
				type = "description",
				name = tostring(value),
				order = descs+1,
				width = "default",
			}
			descs = descs+1
			--[[ret[tostring(descs+1)] = {
				type = "description",
				name = "",
				width = "half",
				order = descs+1,
			}
			descs = descs+1--]]
		end
	end
	return ret
end

function BrowseTable:UpdateTable()
	if not self.currtable then return end
	self.options.args = {root = {name=self.currname, type = "group", order = 2, args= tablebrowser(self.currtable)}}
	self.options.args.update = {name = "Update", desc = "Update the table", type = "execute", func = "UpdateTable", order=1}
end

local function OpenTable(input)
	if input=="" then print("Usage: /browse <table>") return end
	local t = _G
	for key in string.gmatch(input, "[^%.]+") do
		if not t then break end
		t = t[key]
	end
	if not t then print("Table "..input.." not found") return end
	if type(t) ~= "table" then print("Variable "..t.." is not a table, but a "..type(t)..".") return end
	BrowseTable.currtable = t
	BrowseTable.currname = input
	BrowseTable:UpdateTable()
	LibStub("AceConfigDialog-3.0"):Open("BrowseTable")
end
SlashCmdList["BROWSETABLE"] = OpenTable
SLASH_BROWSETABLE1 = "/browse"
SLASH_BROWSETABLE2 = "/browsetable"
